export {displayBelong,CommandPrefix,OpenSetting,OpenEntitySetting,OpenBlockSetting,OpenPlayerSetting,OpenDisplaySetting,Reload,UILatency,TipsLatency,DisplayHelp}

//config file

/**
 * displayBelong
 * This object is used to configure the display of custom module blocks.
 * If not filled, the default will be displayed.
 * 
 * Key Name: Identifier of the module
 * Key Value: Custom name
 * 
 * CommandPrefix
 * The command prefix cannot be '/', and if left blank, no prefix is required.
 * 
 * OpenSetting
 * Command to open the settings interface.
 * 
 * OpenEntitySetting
 * Command to open the block settings interface.
 * 
 * OpenPlayerSetting
 * Command to open the player settings interface.
 * 
 * OpenDisplaySetting
 * Command to open the display settings.
 * 
 * DisplayHelp
 * Command to open help.
 * 
 * Reload
 * Command to reset settings.
 * 
 * UILatency
 * Open UI delay.
 * Since the chat bar needs to be closed after input, a certain delay is required.
 * It can be adjusted according to device performance, and 30 is generally sufficient.
 * 
 * TipsLatency
 * Delay for in-game tip messages.
 * It can be adjusted according to device performance.
 */
let displayBelong = {
    "minecraft":"Minecraft"//This is just an example, you can delete it.
}

//Commands
//Case insensitive
let CommandPrefix = '#'
let OpenSetting = 'Settings'
let OpenEntitySetting = 'EntitySettings'
let OpenBlockSetting = 'BlockSettings'
let OpenPlayerSetting = 'PlayerSettings'
let OpenDisplaySetting = 'DisplaySettings'
let DisplayHelp = 'Help'
let Reload = 'Reload'
let UILatency = 30 // 1s = 20 ticks
let TipsLatency = 200