import * as mc from "@minecraft/server"
import { armorValue } from "./armor"
let Op = String.fromCodePoint(0xe60a)
let Totem = String.fromCodePoint(0xe60b)
let Shield = String.fromCodePoint(0xe60c)
export function getPlayerOp(entity,player) {
    if (entity.isOp() && player.getDynamicProperty('管理员状态')) {
         return " " + Op
    } else {
         return ""
    }
}

export function getGameMode(entity,player) {
     if(player.getDynamicProperty('玩家模式')){
          if (entity.getGameMode() == "creative") {
               return "\n[§cSreate§r] "
          } else if (entity.getGameMode() == "adventure") {
               return "\n[§bAdventure§r] "
          } else {
               return ""
          }
     }else{
          return ''
     }
}

export function armor(entity) {
    let Armor = 0
    let getHead = entity.getComponent(mc.EntityComponentTypes.Equippable)
         ?.getEquipment("Head")
    let getChest = entity.getComponent(mc.EntityComponentTypes.Equippable)
         ?.getEquipment("Chest")
    let getLegs = entity.getComponent(mc.EntityComponentTypes.Equippable)
         ?.getEquipment("Legs")
    let getFeet = entity.getComponent(mc.EntityComponentTypes.Equippable)
         ?.getEquipment("Feet")
    // 累加头盔的护甲值
    if (getHead && getHead.typeId != undefined) {
         Armor += armorValue[getHead.typeId];
    }

    // 累加胸甲的护甲值
    if (getChest && getChest.typeId != undefined) {
         Armor += armorValue[getChest.typeId];
    }

    // 累加护腿的护甲值
    if (getLegs && getLegs.typeId != undefined) {
         Armor += armorValue[getLegs.typeId];
    }

    // 累加靴子的护甲值
    if (getFeet && getFeet.typeId != undefined) {
         Armor += armorValue[getFeet.typeId];
    }
    return Armor

}
export function getMainHandItems(entity,player) {
    let mainhandItem = entity.getComponent(mc.EntityComponentTypes.Equippable).getEquipment("Mainhand")
    try {
         if (mainhandItem.typeId == 'minecraft:shield' && player.getDynamicProperty('盾牌')) {
              return Shield
         } else if (mainhandItem.typeId == 'minecraft:totem_of_undying' && player.getDynamicProperty('不死图腾')) {
              return Totem
         }
    } catch {
         return undefined
    }
}

export function getOffHandItems(entity,player) {
    let offhandItem = entity.getComponent(mc.EntityComponentTypes.Equippable).getEquipment("Offhand")
    try {
         if (offhandItem.typeId == 'minecraft:shield' && player.getDynamicProperty('盾牌')) {
              return Shield
         } else if (offhandItem.typeId == 'minecraft:totem_of_undying' && player.getDynamicProperty('不死图腾')) {
              return Totem
         }
    } catch {
         return undefined
    }
}

