// Portions of this code are derived from the work of r4isen1920 and are used under the MIT License.
// Copyright 2021 r4isen1920
// See the LICENSE file for license rights and limitations (https://opensource.org/licenses/MIT).
// Note: Modifications have been made to the original code.

export const blockName = new Map([
    ['cobblestone_wall', 'cobblestone_wall.normal'],
    ['grass_block', 'grass'],
    ['oak_fence', 'fence'],
    ['spruce_fence', 'spruceFence'],
    ['birch_fence', 'birchFence'],
    ['jungle_fence', 'jungleFence'],
    ['acacia_fence', 'acaciaFence'],
    ['dark_oak_fence', 'darkOakFence'],
    ['oak_leaves', 'leaves.oak'],
    ['spruce_leaves', 'leaves.spruce'],
    ['birch_leaves', 'leaves.birch'],
    ['jungle_leaves', 'leaves.jungle'],
    ['acacia_leaves', 'leaves.acacia'],
    ['dark_oak_leaves', 'leaves.big_oak'],
    ['oak_planks', 'planks.oak'],
    ['spruce_planks', 'planks.spruce'],
    ['birch_planks', 'planks.birch'],
    ['jungle_planks', 'planks.jungle'],
    ['acacia_planks', 'planks.acacia'],
    ['dark_oak_planks', 'planks.big_oak'],
    ['oak_log', 'log.oak'],
    ['spruce_log', 'log.spruce'],
    ['birch_log', 'log.birch'],
    ['jungle_log', 'log.jungle'],
    ['acacia_log', 'log.acacia'],
    ['dark_oak_log', 'log.big_oak'],
    ['oak_wood', 'wood.oak'],
    ['spruce_wood', 'wood.spruce'],
    ['birch_wood', 'wood.birch'],
    ['jungle_wood', 'wood.jungle'],
    ['acacia_wood', 'wood.acacia'],
    ['dark_oak_wood', 'wood.big_oak'],
    ['stripped_oak_wood', 'wood.stripped.oak'],
    ['stripped_spruce_wood', 'wood.stripped.spruce'],
    ['stripped_birch_wood', 'wood.stripped.birch'],
    ['stripped_jungle_wood', 'wood.stripped.jungle'],
    ['stripped_acacia_wood', 'wood.stripped.acacia'],
    ['stripped_dark_oak_wood', 'wood.stripped.big_oak'],
    ['sapling', 'sapling.oak'],
    ['white_stained_glass', 'stained_glass.white'],
    ['light_gray_stained_glass', 'stained_glass.silver'],
    ['gray_stained_glass', 'stained_glass.gray'],
    ['black_stained_glass', 'stained_glass.black'],
    ['brown_stained_glass', 'stained_glass.brown'],
    ['red_stained_glass', 'stained_glass.red'],
    ['orange_stained_glass', 'stained_glass.orange'],
    ['yellow_stained_glass', 'stained_glass.yellow'],
    ['lime_stained_glass', 'stained_glass.lime'],
    ['green_stained_glass', 'stained_glass.green'],
    ['cyan_stained_glass', 'stained_glass.cyan'],
    ['light_blue_stained_glass', 'stained_glass.light_blue'],
    ['blue_stained_glass', 'stained_glass.blue'],
    ['purple_stained_glass', 'stained_glass.purple'],
    ['magenta_stained_glass', 'stained_glass.magenta'],
    ['pink_stained_glass', 'stained_glass.pink'],
    ['white_stained_glass_pane', 'stained_glass_pane.white'],
    ['light_gray_stained_glass_pane', 'stained_glass_pane.silver'],
    ['gray_stained_glass_pane', 'stained_glass_pane.gray'],
    ['black_stained_glass_pane', 'stained_glass_pane.black'],
    ['brown_stained_glass_pane', 'stained_glass_pane.brown'],
    ['red_stained_glass_pane', 'stained_glass_pane.red'],
    ['orange_stained_glass_pane', 'stained_glass_pane.orange'],
    ['yellow_stained_glass_pane', 'stained_glass_pane.yellow'],
    ['lime_stained_glass_pane', 'stained_glass_pane.lime'],
    ['green_stained_glass_pane', 'stained_glass_pane.green'],
    ['cyan_stained_glass_pane', 'stained_glass_pane.cyan'],
    ['light_blue_stained_glass_pane', 'stained_glass_pane.light_blue'],
    ['blue_stained_glass_pane', 'stained_glass_pane.blue'],
    ['purple_stained_glass_pane', 'stained_glass_pane.purple'],
    ['magenta_stained_glass_pane', 'stained_glass_pane.magenta'],
    ['pink_stained_glass_pane', 'stained_glass_pane.pink'],
    ['wooden_door', 'item.wooden_door'],
    ['spruce_door', 'item.spruce_door'],
    ['birch_door', 'item.birch_door'],
    ['jungle_door', 'item.jungle_door'],
    ['acacia_door', 'item.acacia_door'],
    ['dark_oak_door', 'item.dark_oak_door'],
    ['mangrove_door', 'item.mangrove_door'],
    ['cherry_door', 'item.cherry_door'],
    ['white_concrete', 'concrete.white'],
    ['light_gray_concrete', 'concrete.silver'],
    ['gray_concrete', 'concrete.gray'],
    ['black_concrete', 'concrete.black'],
    ['brown_concrete', 'concrete.brown'],
    ['red_concrete', 'concrete.red'],
    ['orange_concrete', 'concrete.orange'],
    ['yellow_concrete', 'concrete.yellow'],
    ['lime_concrete', 'concrete.lime'],
    ['green_concrete', 'concrete.green'],
    ['cyan_concrete', 'concrete.cyan'],
    ['light_blue_concrete', 'concrete.lightBlue'],
    ['blue_concrete', 'concrete.blue'],
    ['purple_concrete', 'concrete.purple'],
    ['magenta_concrete', 'concrete.magenta'],
    ['pink_concrete', 'concrete.pink'],
    ['white_concrete_powder', 'concretePowder.white'],
    ['light_gray_concrete_powder', 'concretePowder.silver'],
    ['gray_concrete_powder', 'concretePowder.gray'],
    ['black_concrete_powder', 'concretePowder.black'],
    ['brown_concrete_powder', 'concretePowder.brown'],
    ['red_concrete_powder', 'concretePowder.red'],
    ['orange_concrete_powder', 'concretePowder.orange'],
    ['yellow_concrete_powder', 'concretePowder.yellow'],
    ['lime_concrete_powder', 'concretePowder.lime'],
    ['green_concrete_powder', 'concretePowder.green'],
    ['cyan_concrete_powder', 'concretePowder.cyan'],
    ['light_blue_concrete_powder', 'concretePowder.lightBlue'],
    ['blue_concrete_powder', 'concretePowder.blue'],
    ['purple_concrete_powder', 'concretePowder.purple'],
    ['magenta_concrete_powder', 'concretePowder.magenta'],
    ['pink_concrete_powder', 'concretePowder.pink'],
    ['white_glazed_terracotta', 'glazedTerracottaWhite'],
    ['silver_glazed_terracotta', 'glazedTerracottaSilver'],
    ['gray_glazed_terracotta', 'glazedTerracottaGray'],
    ['black_glazed_terracotta', 'glazedTerracottaBlack'],
    ['brown_glazed_terracotta', 'glazedTerracottaBrown'],
    ['red_glazed_terracotta', 'glazedTerracottaRed'],
    ['orange_glazed_terracotta', 'glazedTerracottaOrange'],
    ['yellow_glazed_terracotta', 'glazedTerracottaYellow'],
    ['lime_glazed_terracotta', 'glazedTerracottaLime'],
    ['green_glazed_terracotta', 'glazedTerracottaGreen'],
    ['cyan_glazed_terracotta', 'glazedTerracottaCyan'],
    ['light_blue_glazed_terracotta', 'glazedTerracottaLightBlue'],
    ['blue_glazed_terracotta', 'glazedTerracottaBlue'],
    ['purple_glazed_terracotta', 'glazedTerracottaPurple'],
    ['magenta_glazed_terracotta', 'glazedTerracottaMagenta'],
    ['pink_glazed_terracotta', 'glazedTerracottaPink'],
    ['white_terracotta', 'stained_hardened_clay.white'],
    ['light_gray_terracotta', 'stained_hardened_clay.silver'],
    ['gray_terracotta', 'stained_hardened_clay.gray'],
    ['black_terracotta', 'stained_hardened_clay.black'],
    ['brown_terracotta', 'stained_hardened_clay.brown'],
    ['red_terracotta', 'stained_hardened_clay.red'],
    ['orange_terracotta', 'stained_hardened_clay.orange'],
    ['yellow_terracotta', 'stained_hardened_clay.yellow'],
    ['lime_terracotta', 'stained_hardened_clay.lime'],
    ['green_terracotta', 'stained_hardened_clay.green'],
    ['cyan_terracotta', 'stained_hardened_clay.cyan'],
    ['light_blue_terracotta', 'stained_hardened_clay.lightBlue'],
    ['blue_terracotta', 'stained_hardened_clay.blue'],
    ['purple_terracotta', 'stained_hardened_clay.purple'],
    ['magenta_terracotta', 'stained_hardened_clay.magenta'],
    ['pink_terracotta', 'stained_hardened_clay.pink'],
    ['white_carpet', 'carpet.white'],
    ['light_gray_carpet', 'carpet.silver'],
    ['gray_carpet', 'carpet.gray'],
    ['black_carpet', 'carpet.black'],
    ['brown_carpet', 'carpet.brown'],
    ['red_carpet', 'carpet.red'],
    ['orange_carpet', 'carpet.orange'],
    ['yellow_carpet', 'carpet.yellow'],
    ['lime_carpet', 'carpet.lime'],
    ['green_carpet', 'carpet.green'],
    ['cyan_carpet', 'carpet.cyan'],
    ['light_blue_carpet', 'carpet.lightBlue'],
    ['blue_carpet', 'carpet.blue'],
    ['purple_carpet', 'carpet.purple'],
    ['magenta_carpet', 'carpet.magenta'],
    ['pink_carpet', 'carpet.pink'],
    ['white_wool', 'wool.white'],
    ['light_gray_wool', 'wool.silver'],
    ['gray_wool', 'wool.gray'],
    ['black_wool', 'wool.black'],
    ['brown_wool', 'wool.brown'],
    ['red_wool', 'wool.red'],
    ['orange_wool', 'wool.orange'],
    ['yellow_wool', 'wool.yellow'],
    ['lime_wool', 'wool.lime'],
    ['green_wool', 'wool.green'],
    ['cyan_wool', 'wool.cyan'],
    ['light_blue_wool', 'wool.lightBlue'],
    ['blue_wool', 'wool.blue'],
    ['purple_wool', 'wool.purple'],
    ['magenta_wool', 'wool.magenta'],
    ['pink_wool', 'wool.pink'],
    ['stone', 'stone.stone'],
    ['andesite', 'stone.andesite'],
    ['diorite', 'stone.diorite'],
    ['granite', 'stone.granite'],
    ['polished_andesite', 'stone.andesiteSmooth'],
    ['polished_diorite', 'stone.dioriteSmooth'],
    ['polished_granite', 'stone.graniteSmooth'],
    ['wall_banner','standing_banner'],
    ['prismarine', 'prismarine.rough'],
    ['stone_block_slab', 'stone_slab'],
    ['stone_block_slab2', 'double_stone_slab2.red_sandstone'],
    ['stone_block_slab3', 'stone_slab3.end_brick'],
    ['stone_block_slab4', 'stone_slab4.mossy_stone_brick'],
    ['double_stone_block_slab', 'double_stone_slab'],
    ['double_stone_block_slab2', 'double_stone_slab2.red_sandstone'],
    ['double_stone_block_slab3', 'double_stone_slab3.end_brick'],
    ['double_stone_block_slab4', 'double_stone_slab4.mossy_stone_brick'],
    ['oak_slab', 'wooden_slab.oak'],
    ['spruce_slab', 'wooden_slab.spruce'],
    ['birch_slab', 'wooden_slab.birch'],
    ['jungle_slab', 'wooden_slab.jungle'],
    ['acacia_slab', 'wooden_slab.acacia'],
    ['dark_oak_slab', 'wooden_slab.big_oak'],
    ['oak_double_slab', 'wooden_slab.oak'],
    ['spruce_double_slab', 'wooden_slab.spruce'],
    ['birch_double_slab', 'wooden_slab.birch'],
    ['jungle_double_slab', 'wooden_slab.jungle'],
    ['acacia_double_slab', 'wooden_slab.acacia'],
    ['dark_oak_double_slab', 'wooden_slab.big_oak'],
    ['fire_coral', 'coral.red'],
    ['brain_coral', 'coral.pink'],
    ['bubble_coral', 'coral.purple'],
    ['tube_coral', 'coral.blue'],
    ['horn_coral', 'coral.yellow'],
    ['dead_fire_coral', 'coral.red_dead'],
    ['dead_brain_coral', 'coral.pink_dead'],
    ['dead_bubble_coral', 'coral.purple_dead'],
    ['dead_tube_coral', 'coral.blue_dead'],
    ['dead_horn_coral', 'coral.yellow_dead'],
    ['coral_block', 'coral_block.blue'],
    ['coral_fan_dead', 'coral_fan_dead.blue_fan'],
    ['brewing_stand', 'item.brewing_stand'],
    ['acacia_hanging_sign', 'item.acacia_hanging_sign'],
    ['bamboo_hanging_sign', 'item.bamboo_hanging_sign'],
    ['birch_hanging_sign', 'item.birch_hanging_sign'],
    ['cherry_hanging_sign', 'item.cherry_hanging_sign'],
    ['crimson_hanging_sign', 'item.crimson_hanging_sign'],
    ['dark_oak_hanging_sign', 'item.dark_oak_hanging_sign'],
    ['jungle_hanging_sign', 'item.jungle_hanging_sign'],
    ['mangrove_hanging_sign', 'item.mangrove_hanging_sign'],
    ['oak_hanging_sign', 'item.oak_hanging_sign'],
    ['spruce_hanging_sign', 'item.spruce_hanging_sign'],
    ['warped_hanging_sign', 'item.warped_hanging_sign'],
    ['acacia_standing_sign', 'item.acacia_sign'],
    ['bamboo_standing_sign', 'item.bamboo_sign'],
    ['birch_standing_sign', 'item.birch_sign'],
    ['cherry_standing_sign', 'item.cherry_sign'],
    ['crimson_standing_sign', 'item.crimson_sign'],
    ['dark_oak_standing_sign', 'item.dark_oak_sign'],
    ['jungle_standing_sign', 'item.jungle_sign'],
    ['mangrove_standing_sign', 'item.mangrove_sign'],
    ['standing_sign', 'item.sign'],
    ['spruce_standing_sign', 'item.spruce_sign'],
    ['warped_standing_sign', 'item.warped_sign'],
    ['acacia_wall_sign', 'item.acacia_sign'],
    ['bamboo_wall_sign', 'item.bamboo_sign'],
    ['birch_wall_sign', 'item.birch_sign'],
    ['cherry_wall_sign', 'item.cherry_sign'],
    ['crimson_wall_sign', 'item.crimson_sign'],
    ['dark_oak_wall_sign', 'item.dark_oak_sign'],
    ['jungle_wall_sign', 'item.jungle_sign'],
    ['mangrove_wall_sign', 'item.mangrove_sign'],
    ['wall_sign', 'item.sign'],
    ['spruce_wall_sign', 'item.spruce_sign'],
    ['warped_wall_sign', 'item.warped_sign'],
    ['frame', 'item.frame'],
    ['glow_frame', 'item.glow_frame'],
    ['seagrass', 'seagrass.seagrass'],
    ["fern", "double_plant.fern"],
    ["large_fern", "double_plant.fern"],
    ["tall_grass", "double_plant.grass"],
    ["grass", "double_plant.grass"],
    ["short_grass", "tallgrass.grass"],
    ["dandelion", "yellow_flower.dandelion"],
    ["poppy", "red_flower.poppy"],
    ["blue_orchid", "red_flower.blueOrchid"],
    ["allium", "red_flower.allium"],
    ["azure_bluet", "red_flower.houstonia"],
    ["red_tulip", "red_flower.tulipRed"],
    ["orange_tulip", "red_flower.tulipOrange"],
    ["white_tulip", "red_flower.tulipWhite"],
    ["pink_tulip", "red_flower.tulipPink"],
    ["oxeye_daisy", "red_flower.oxeyeDaisy"],
    ["cornflower", "red_flower.cornflower"],
    ["lily_of_the_valley", "red_flower.lilyOfTheValley"],
    ["sunflower", "double_plant.sunflower"],
    ["lilac", "double_plant.syringa"],
    ["rose_bush", "double_plant.rose"],
    ["peony", "double_plant.paeonia"],
    ["seagrass", "seagrass.seagrass"],
    ["wheat", "item.wheat"],
    ["lit_redstone_ore","redstone_ore"],
    ["lit_deepslate_redstone_ore","deepslate_redstone_ore"],
    ["unpowered_repeater","item.repeater"],
    ["unpowered_comparator","item.comparator"],
    ["powered_comparator","item.comparator"]
  ])