import { toolName } from "../tool/tool"
import { blockTags, cannotDestruction, useHand } from "../tool/blockTypeId"
import { needeToolLevel, needeToolType, handToolLevel, handToolType } from "../tool/toolLevel"
import { yes, nyes, no, mature, immature, disableFunnels, isUpperHalfOrder, maxDistance } from "./state"
import { displayBelong } from "../config"
import { blockName } from "./blockName"
export function lookBlock(player, block, hand) {
     const info = []
     const id = block.typeId//获取方块id
     const { x, y, z } = block//获取方块坐标
     const identifier = block.typeId.split(":")[0]//只读取冒号前面的标识符
     const mcid = block.typeId.split(":")[1]//只截取方块前部分的标识符
     const belong = identifier.slice(0, 1).toUpperCase() + identifier.slice(1)//首字母大写
     const canGather = []//可以被采集
     const bestTool = []//最佳工具
     const gatherLevel = []//采集等级
     const isInventory = block?.getComponent("inventory")//容器组件
     const sign = block?.getComponent('sign')
     const plantMatures = []//植物成熟
     const hasRedstonePower = []//红石信号
     const chestInventory = []//箱子容量
     const isSign = []//告示牌
     const towards = []//方块朝向
     const brushedprogres = []//可疑沙子
     const delay = []//红石中继器
     const anchor = []//重生锚
     const composterFillLevel = []//堆肥桶高度
     const isCauldron = []//炼药锅
     const isHopper = []//漏斗
     const isStairs = []//台阶
     const isStability = []//脚手架
     const isHoney = []
     const blockId = block.typeId.split(":")[1]//只获取后面的
     // console.log(block.permutation.getState('color'));
     // 这里是关于红石的
     if (block.getRedstonePower() != undefined) {
          if (getLeverState(block) != undefined) {
               if (player.getDynamicProperty('红石状态'))
                    hasRedstonePower.push(`State:${getLeverState(block)}\n`)
          } else {
               if (player.getDynamicProperty('红石能量'))
                    hasRedstonePower.push(`Redstone Charges:${block.getRedstonePower() > 0 ? "§a" + block.getRedstonePower() : "§c" + block.getRedstonePower()}§r\n`)
          }
     }
     //比较器模式
     if (getComparatorMode(block) != undefined && player.getDynamicProperty('比较器')) {
          hasRedstonePower.push(`Comparator Status:${getComparatorMode(block)}\n`)
     }
     //告示牌文字
     if (sign && player.getDynamicProperty('告示牌')) {
          isSign.push("§l§bContent:§r\n" + sign.getText() + "§r\n")
     }
     // 这里是关于箱子容器的
     if (isInventory && player.getDynamicProperty('容器')) {
          const inventory = isInventory.container
          const isMax = inventory.size - inventory.emptySlotsCount == inventory.size
          const remainder = inventory.size - inventory.emptySlotsCount
          // let { emptySlotsCount, size } = inventory
          chestInventory.push(`Container Capacity:${!isMax ? "§a" + remainder : "§c" + remainder}/${inventory.size}§r\n`)
     }
     // 这里是植物生长阶段
     if (getPlankLevel(block, player) != undefined && player.getDynamicProperty('植物')) {
          if(block.typeId != 'minecraft:pumpkin')
          plantMatures.push(`Plant Stage:${getPlankLevel(block, player)}\n`)
     }
     // 方块朝向
     if (player.getDynamicProperty('朝向')) {
          if (getTowards(block) != undefined) {
               towards.push(`Block Direction:${getTowards(block)}\n`)
          } else if (getBlockTowards(block) != undefined) {
               towards.push(`Block Direction:${getBlockTowards(block)}\n`)
          }
     }
     // 可疑的沙子被刷程度
     if (getBrushedprogress(block, player) != undefined && player.getDynamicProperty('可疑沙子')) {
          brushedprogres.push(`Progress:${getBrushedprogress(block, player)}\n`)
     }
     if (block.typeId == 'minecraft:farmland' || block.typeId == 'minecraft:soul_sand') {
          if (block.above(1).isAir) {
               plantMatures.push(`Plant phase: §cNot planted§r\n`)
          }
     }
     //中继器延迟
     if (getDelay(block) != undefined && player.getDynamicProperty('中继器')) {
          delay.push(`Repeater Delay:${getDelay(block)}\n`)
     }
     // 重生锚
     if (getAnchor(block) != undefined && player.getDynamicProperty('重生锚')) {
          anchor.push(`Respawn Anchor Charges:${getAnchor(block)}\n`)
     }
     // 堆肥桶
     if (getComposterLevel(block, player) != undefined && player.getDynamicProperty('堆肥箱')) {
          composterFillLevel.push(`Composter Capacity:${getComposterLevel(block, player)}\n`)
     }
     // 炼药锅
     if (id == 'minecraft:cauldron') {
          if (player.getDynamicProperty('炼药锅装有')) {
               isCauldron.push(`Contents of the Cauldron${getCauldron(block, player).cauldron_liquid()}\n`)
          }

          if (player.getDynamicProperty('炼药锅容量')) {
               isCauldron.push(`Cauldron Capacity:${getCauldron(block, player).fill_level()}\n`)
          }
     }
     //漏斗状态
     if (toggle(block) != undefined && player.getDynamicProperty('漏斗')) {
          isHopper.push(toggle(block))
     }

     if (stairs(block) != undefined && player.getDynamicProperty('台阶')) {
          isStairs.push(stairs(block))
     }

     //脚手架
     if (stability(block) != undefined && player.getDynamicProperty('脚手架')) {
          isStability.push(`Scaffolding Distance:${stability(block)}\n`)
     }

     //蜂蜜容量
     if (getHoney(block, player) != undefined && player.getDynamicProperty('蜂蜜')) {
          isHoney.push(`Honey Capacity:${getHoney(block, player)}\n`)
     }

     if (player.isSneaking) {
          // 已经弃用是否固体等，因为实在没啥用还影响观感，如果你需要可以取消注释
          if (player.getDynamicProperty('固体'))
               info.push(`Is Solid:${block.isSolid ? yes : no}`)

          if (player.getDynamicProperty('浸水'))
               info.push(`Is Wet:${block.isWaterlogged ? yes : no}`)

          //获取三原色，貌似没啥用
          if (player.getDynamicProperty('三原色'))
               info.push(`§c${block.getMapColor().red.toFixed(2)} §a${block.getMapColor().green.toFixed(2)} §b${block.getMapColor().blue.toFixed(2)}§r`)

          if (player.getDynamicProperty('方块标识符'))
               info.push(id)

          if (player.getDynamicProperty('方块坐标'))
               info.push(`x:${x} y:${y} z:${z}`)
     }
     const neededLevel = needeToolLevel(mcid, block)
     //下面的采集信息请不要使用变量的形式显示，因为写成硬编码可以方便追踪错误
     let Mined = "Mined"
     if (cannotDestruction.includes(mcid)) {
          canGather.push(`\n${toolName.cannotDestruction}`)
     } else {
          if (neededLevel === 0 && hasBlockTag(block)) {
               if (handToolType(hand) == getBlockTool(block)) {
                    if (handToolLevel(hand) >= getBlockLevel(block)) {
                         canGather.push(`\n${Mined}:${yes}`) // 正确的工具和等级
                    } else {
                         canGather.push(`\n${Mined}:${no}`);// 正确的工具，但等级不够
                    }
               } else {
                    if (blockCanHand(block)) {
                         canGather.push(`\n${Mined}:${nyes}`) // 非最佳工具
                    } else {
                         canGather.push(`\n${Mined}:${no}`); // 错误的工具
                    }
               }
          } else if (neededLevel === 0) {
               canGather.push(`\n${Mined}:${yes}`); // 可以采集
          } else {
               const handType = handToolType(hand)
               const handLevel = handToolLevel(hand)
               const neededType = needeToolType(mcid, block)
               if (handType === neededType) {
                    if (handLevel >= neededLevel) {
                         canGather.push(`\n${Mined}:${yes}`); // 正确的工具和等级
                    } else {
                         canGather.push(`\n${Mined}:${no}`); // 正确的工具，但等级不够
                    }
               } else if (useHand.includes(mcid) || block?.getTags().includes('minecraft:canUseHand')) {
                    canGather.push(`\n${Mined}:${nyes}`) // 非最佳工具
               } else {
                    canGather.push(`\n${Mined}:${no}`); // 错误的工具
               }
          }
     }
     //也包括这里
     let BestTool = "Best Tool"
     let HarvestLevel = "Harvest Level"
     
     if (!cannotDestruction.includes(mcid)) {
          if (hasBlockTag(block) && neededLevel == 0) {
               bestTool.push(`\n${BestTool}:${getBlockTool(block) == handToolType(hand) ? "§a" + getBlockTool(block) : "§c" + getBlockTool(block)}§r`)
               if (getBlockLevel(block) > handToolLevel(hand)) {
                    gatherLevel.push(`\n${HarvestLevel}:§c${getBlockLevel(block)}§r`)
               } else {
                    gatherLevel.push(`\n${HarvestLevel}:§a${getBlockLevel(block)}§r`)
               }
          }
          else if (neededLevel == 0) {
               bestTool.push(`\n${BestTool}:${needeToolType(mcid, block) == handToolType(hand) ? "§a" + needeToolType(mcid, block) : "§c" + needeToolType(mcid, block)}§r`)
               gatherLevel.push(`\n${HarvestLevel}:§a${needeToolLevel(mcid, block)}§r`)
          } else {
               if (needeToolLevel(mcid, block) > handToolLevel(hand)) {
                    bestTool.push(`\n${BestTool}:${needeToolType(mcid, block) == handToolType(hand) ? "§a" + needeToolType(mcid, block) : "§c" + needeToolType(mcid, block)}§r`)
                    gatherLevel.push(`\n${HarvestLevel}:§c${needeToolLevel(mcid, block)}§r`)
               } else {
                    bestTool.push(`\n${BestTool}:${needeToolType(mcid, block) == handToolType(hand) ? "§a" + needeToolType(mcid, block) : "§c" + needeToolType(mcid, block)}§r`)
                    gatherLevel.push(`\n${HarvestLevel}:§a${needeToolLevel(mcid, block)}§r`)
               }
          }
     }
     // 这里是用来显示模组归属的
     let displayAddon = belong
     for (const [key, value] of Object.entries(displayBelong)) {
          if (key === identifier) {
               displayAddon = [`§r§9${value}`]
               break//退出循环
          }
     }
     if (player.getDynamicProperty('方块信息')) {
          player.onScreenDisplay.setActionBar({
               rawtext: [
                    { translate: disPlayNameBlock(blockId) },
                    { text: player.getDynamicProperty('能否采集') ? `${canGather}` : '' },
                    { text: player.getDynamicProperty('采集工具') ? `${bestTool}` : '' },
                    { text: player.getDynamicProperty('采集等级') ? `${gatherLevel}` : '' },
                    { text: `\n${isSign}${chestInventory}${hasRedstonePower.join('')}${delay}${plantMatures}${towards}${brushedprogres}${anchor}${composterFillLevel}${isCauldron.join('')}${isHopper}${isStairs}${isStability}${isHoney}` },
                    { text: info.join('\n') },
                    { translate: AddonBelong(player, displayAddon) }
               ]
          })
     }
}

function AddonBelong(player, displayAddon) {
     if (player.getDynamicProperty('方块模组归属')) {
          return `§r§9${player.isSneaking ? "\n" + displayAddon : displayAddon}§r`
     } else {
          return ''
     }

}

function getCauldron(block, player) {
     let permutation = block.permutation
     let type = {
          "water": "Water",
          "lava": "lava",
          "powder_snow": "Powder Snow",
     }
     return {
          cauldron_liquid: function () {
               if (permutation?.getState('cauldron_liquid') != undefined) {
                    return type[permutation?.getState('cauldron_liquid')]
               }
          },
          fill_level: function () {
               let level = permutation?.getState('fill_level')
               if (level != undefined) {
                    if (player.getDynamicProperty('炼药锅容量百分比')) {
                         const percentage = (level / 6) * 100
                         return percentage.toFixed(2) + '%'
                    } else {
                         return level == 6 ? '§c' + level : level
                    }

               }
          }
     }
}

function disPlayNameBlock(blockId) {
     let special = [
          "wooden_door",
          "iron_door",
          "spruce_door",
          "birch_door",
          "jungle_door",
          "acacia_door",
          "dark_oak_door",
          "bamboo_door",
          "cherry_door",
          "mangrove_door",
          "wheat",
          "unpowered_repeater",
          "unpowered_comparator",
          "powered_comparator"
     ]

     if (special.includes(blockId)) {
          return `${blockName.get(blockId)}.name`
     } else if (blockName.has(blockId)) {
          return `tile.${blockName.get(blockId)}.name`
     } else {
          return `tile.${blockId}.name`
     }
}
let getGrowth = {
     "minecraft:wheat": 7,
     "minecraft:pumpkin_stem": 7,
     "minecraft:melon_stem": 7,
     "minecraft:beetroot": 7,
     "minecraft:pitcher_crop": 4,
     "minecraft:potatoes": 7,
     "minecraft:carrots": 7,
     "minecraft:sweet_berry_bush": 3
}

let getAge = {
     "minecraft:cocoa": 2,
     "minecraft:nether_wart": 3,
}

// 植物生长阶段
function getPlankLevel(block, player) {
     let id = block.typeId
     let permutation = block.permutation
     // console.log(permutation.getState('age'));

     if (Object.keys(getGrowth).some(key => key.startsWith(id))) {
          if (player.getDynamicProperty('植物百分比')  && block.typeId != 'minecraft:pumpkin') {
               const percentage = (permutation.getState('growth') / getGrowth[id]) * 100
               return percentage.toFixed(2) + '%'
          } else {
               if (permutation.getState('growth') == getGrowth[id]) {
                    return mature
               } else {
                    return immature
               }
          }
     }
     if (Object.keys(getAge).some(key => key.startsWith(id))) {
          if (player.getDynamicProperty('植物百分比')) {
               const percentage = (permutation.getState('age') / getAge[id]) * 100
               return percentage.toFixed(2) + '%'
          } else {
               if (permutation.getState('age') == getAge[id]) {
                    return mature
               } else {
                    return immature
               }
          }
     }

     if (block.typeId == 'minecraft:cactus' || block.typeId == 'minecraft:reeds') {
          if (player.getDynamicProperty('植物百分比')) {
               const percentage = (permutation.getState('age') / 15) * 100
               return percentage.toFixed(2) + '%'
          } else {
               return `${permutation.getState('age')}/15`
          }
     }

}

// 一般朝向
function getTowards(block) {
     let permutation = block.permutation
     let blockTowards = ["Down", "Up", "North", "South", "West", "East"]
     return blockTowards[permutation?.getState('facing_direction')]
}

// 特殊方块朝向，没有上下
function getBlockTowards(block) {
     let permutation = block.permutation
     let blockTowards = {
    "south": "South",
    "west": "West",
    "north": "North",
    "east": "East"
}
     return blockTowards[permutation?.getState('minecraft:cardinal_direction')]
}

function getBrushedprogress(block, player) {
     let permutation = block.permutation
     const brushed_progress = permutation?.getState('brushed_progress')
     if (brushed_progress != undefined) {
          if (player.getDynamicProperty('可疑沙子百分比')) {
               const percentage = (brushed_progress / 4) * 100
               return percentage.toFixed(2) + '%'
          } else {
               return brushed_progress + '/4'
          }
     } else {
          return undefined
     }


}

function getDelay(block) {
     let permutation = block.permutation
     const repeater_delay = permutation?.getState('repeater_delay')
     let delyLevel = ["§a", "§e", "§p", "§c"]
     if (repeater_delay != undefined) {
          return delyLevel[repeater_delay] + repeater_delay + '§r'
     }
}

function getComparatorMode(block) {
     let permutation = block.permutation
     let mode = permutation?.getState('output_subtract_bit')
     if (mode != undefined)
          return mode ? 'Subtraction' : 'Comparison'
}

function getComposterLevel(block, player) {
     let permutation = block.permutation
     const level = permutation?.getState('composter_fill_level')
     if (level != undefined) {
          if (player.getDynamicProperty('堆肥箱百分比')) {
               const percentage = (level / 8) * 100
               return percentage.toFixed(2) + '%'
          } else {
               return `${level}/8`
          }

     }
}
function getAnchor(block) {
     let permutation = block.permutation
     const respawn_anchor_charge = permutation?.getState('respawn_anchor_charge')
     let anchorLevel = ["§c", "§p", "§e", "§b", "§a"]
     if (respawn_anchor_charge != undefined) {
          return anchorLevel[respawn_anchor_charge] + respawn_anchor_charge + '§r'
     }
}

function getLeverState(block) {
     let permutation = block.permutation
     const state = permutation?.getState('open_bit')
     if (state != undefined) {
          return state ? '§aOpen§r' : '§cClosed§r';
     }
}


function toggle(block) {
     let permutation = block.permutation
     let canToggle = permutation?.getState('toggle_bit')
     if (canToggle != undefined) {
          return canToggle ? disableFunnels + '\n' : ''
     } else {
          return undefined
     }
}

function stairs(block) {
     let permutation = block.permutation
     let upperHalfOrder = permutation?.getState('top_slot_bit')
     if (upperHalfOrder != undefined) {
          return upperHalfOrder ? isUpperHalfOrder + '\n' : ''
     } else {
          return undefined
     }
}
function stability(block) {
     let permutation = block.permutation
     const stabilityDistance = permutation?.getState('stability')
     if (stabilityDistance != undefined) {
          return stabilityDistance == 6 ? maxDistance : stabilityDistance
     } else {
          return undefined
     }
}

function getHoney(block, player) {
     let permutation = block.permutation
     const honey_level = permutation?.getState('honey_level')
     if (player.getDynamicProperty('蜂蜜百分比') && honey_level != undefined) {
          const percentage = (honey_level / 5) * 100
          return percentage.toFixed(2) + '%'
     } else {
          if (honey_level != undefined) {
               return honey_level == 5 ? '§c' + honey_level : honey_level
          } else {
               return undefined
          }
     }
}

function hasBlockTag(block) {
     let tags = false
     blockTags.forEach(a => {
          if (block.hasTag(a.tag)) {
               tags = true
          }
     })
     return tags
}

function blockCanHand(block) {
     let canHand = false
     blockTags.forEach(a => {
          if (block.hasTag(a.tag) && a.hand) {
               canHand = true
               return
          }
     })
     return canHand
}

function getBlockLevel(block) {
     let toolLevel = null
     blockTags.some(a => {
          if (block.hasTag(a.tag)) {
               toolLevel = a.level
               return true
          }
          return false
     })
     return toolLevel
}

function getBlockTool(block) {
     let toolTool = null
     blockTags.some(a => {
          if (block.hasTag(a.tag)) {
               toolTool = a.tool
               return true
          }
          return false
     })
     return toolTool
}