import { yes, nyes, no } from "./state"
import { displayBelong } from "../config"
import { getPlayerOp, getGameMode, armor, getMainHandItems, getOffHandItems } from "./DetectPlayer"
import { displayIconArmor, displayIconHealth } from "./healt_arnor"
import { getDevice } from "./displayDevice"
let Hurt = String.fromCodePoint(0xe600) + ' '
export function lookEntity(player, entity) {
     const hasHealth = entity.getComponent("health")
     const health = entity.getComponent("health")?.currentValue//当前健康值
     const defaultHealth = entity.getComponent("health")?.defaultValue//默认健康值
     const movement = entity.getComponent("movement")?.currentValue//移动速度
     const underwaterMovement = entity.getComponent("underwater_movement")?.currentValue//水下移动速度
     const leashable = entity.getComponent("leashable")//是否被栓绳牵引
     const tameable = entity.getComponent("tameable")//是否可以被驯服
     const baby = entity.getComponent("is_baby")//是婴儿
     const identifier = entity.typeId.split(":")[0]//只读取冒号前面的标识符
     const belong = identifier.slice(0, 1).toUpperCase() + identifier.slice(1)
     const skinId = entity.getComponent("skin_id")
     const entityId = entity.typeId.split(":")[1]
     const name = entity.nameTag
     let device
     let entityTarget = ""
     let info = []
     let isPlayer = []
     let playerHand = []
     let getArmor
     let health_boost = 0
     if (entity.getEffect('health_boost')?.amplifier != undefined) {
          health_boost = (entity.getEffect('health_boost').amplifier + 1) * 4
     }
     let maxHealth = health_boost + defaultHealth

     const Armor = armor(entity)

     if (player.isSneaking) {
          if (movement) {
               if (player.getDynamicProperty('移动速度'))
                    info.push(`\nMovement Speed:${movement.toFixed(2)}`)

          }
          if (underwaterMovement) {
               if (player.getDynamicProperty('水下移动速度'))
                    info.push(`\nUnderwater Movement Speed:${underwaterMovement.toFixed(2)}`)
          }
          if (player.getDynamicProperty('能否牵引'))
               info.push(`\nCan be Leashed:${canLeashable(leashable)}`)

          if (player.getDynamicProperty('能否驯服'))
               info.push(`\nCan be Tamed:${canTameable(tameable)}`)

          if (player.getDynamicProperty('生物标识符'))
               info.push('\n' + entity.typeId)
     }
     // 已驯服
     function isTameable(entity) {
          if (player.getDynamicProperty('驯服')) {
               if (entity.typeId == "minecraft:wolf" && canTameable(tameable) == no || entity.typeId == "minecraft:cat" && canTameable(tameable) == no) {
                    return '\n§eTamed§r'
               } else {
                    return ''
               }
          } else {
               return ''
          }
     }
     //是幼崽
     function isBaby(baby) {
          if (player.getDynamicProperty('是幼崽')) {
               if (!!baby) {
                    return '\n§cBaby§r';
               } else {
                    return ''
               }
          } else {
               return ''
          }
     }

     function canLeashable(leashable) {
          if (!!leashable) {
               return yes
          } else {
               return no
          }
     }
     function canTameable(tameable) {
          if (!!tameable) {
               return yes
          } else {
               return no
          }
     }
     if (entity.typeId == 'minecraft:player') {
          getArmor = armor(entity)
          if (getOffHandItems(entity, player) != undefined) {
               playerHand.push(` ${getOffHandItems(entity, player)}`)
          }
          if (getMainHandItems(entity, player) != undefined) {
               playerHand.push(` ${getMainHandItems(entity, player)}`)
          }
          device = entity.clientSystemInfo.platformType
     }
     if (entity.typeId == 'minecraft:player' && player.isSneaking) {
          if (entity.getEffect != undefined && player.getDynamicProperty('药水')) {
               const effects = entity.getEffects()
               try {
                    effects.forEach(effect => {
                         const buffDuration = effect.duration / 20
                         const buffName = effect.displayName
                         isPlayer.push(`§e${buffName}§a(§b${Math.round(buffDuration)},§c${effect.amplifier}§a)§r`)//§c${effect.amplifier}§r 
                         // isPlayer.push(`等级:§c${effect.amplifier}§r 持续时间:§b${Math.round(buffDuration) == 0 ? '无限' : Math.round(buffDuration)}§r `)
                    })
               } catch (error) {
                    console.error(error)
               }
          }
     }
     let displayAddon = belong
     for (const [key, value] of Object.entries(displayBelong)) {
          if (key === identifier) {
               displayAddon = [`§r§9${value}`]
               break//退出循环
          }
     }

     function playerArmor(entity, getArmor) {
          if (player.getDynamicProperty('玩家护甲值')) {
               const Armor = armor(entity)
               if (entity.getGameMode() != "creative") {
                    return "\n" + displayIconArmor(Armor)
               } else {
                    return ""
               }
          } else {
               return ''
          }
     }
     if (player.getDynamicProperty('目标')) {
          if (entity.target != null) {
               entityTarget = "\n§6Hostile Target§r:";
          }
     }
     function TargetName(entity) {
          const entityId = entity.target.typeId.split(":")[1]
          if (entity.target.typeId == 'minecraft:player') {
               return entity.target.name
          } else {
               if (!entity.name) {
                    return `entity.${entityId}.name`
               } else {
                    return entity.name
               }
          }
     }
     function displayPlayerHealth(health, defaultHealth, maxHealth, Hurt) {
          if (player.getDynamicProperty('玩家血量')) {
               const entityHealth = Math.ceil(health)
               const residualBlood = entityHealth <= maxHealth * (player.getDynamicProperty('残血') * 0.01) ? `§c${entityHealth}§r` : entityHealth
               return (health <= 20 && defaultHealth <= 20) ? '\n' + displayIconHealth(health, maxHealth, defaultHealth) : '\n' + Hurt + residualBlood + '/' + maxHealth
          } else {
               return ''
          }
     }
     function playerLevel(entity, player) {
          if (player.getDynamicProperty('等级')) {
               return `\nLevel:§e${entity.level}§r`
          } else {
               return ''
          }
     }
     // player.clientSystemInfo.platformType
     if (entity.typeId == 'minecraft:player' && player.getDynamicProperty('玩家信息')) {
          player.onScreenDisplay.setActionBar({
               rawtext: [
                    { text: `${getDevice(device, player)} ${entity.name}${getPlayerOp(entity, player)}${getGameMode(entity, player)}` },
                    { text: `${displayPlayerHealth(health, defaultHealth, maxHealth, Hurt)}${playerHand.join('')}${playerArmor(entity, getArmor, player)}${playerLevel(entity, player)}\n${isPlayer.join('\n')}` }
               ]
          })
     } else if (hasHealth || health) {
          if (player.getDynamicProperty('生物信息') && entity.typeId != 'minecraft:player') {
               player.onScreenDisplay.setActionBar({
                    rawtext: [
                         { translate: disPlayNameEntity(name, entityId) },
                         { text: `${displayEntityHealth(player, defaultHealth, health, maxHealth)}${isTameable(entity)}${isBaby(baby)}` },
                         { text: `${entityTarget}` },
                         { translate: `${entity.target != null ? TargetName(entity) : ''}` },
                         { text: `${info.join('')}` },
                         { translate: AddonBelong(player, displayAddon) }
                    ]
               })
          }
     }else{
          return undefined
     }
}
function AddonBelong(player, displayAddon) {
     if (player.getDynamicProperty('生物模组归属')) {
          return `§r§9${"\n" + displayAddon}§r`
     } else {
          return
     }

}
function disPlayNameEntity(name, entityId) {
     let entityName = {
          "wolf": "不准给宠物取作者的名字啊喂！",
          "cat": "喵喵喵？",
          "pig": "你才是猪！",
          "cow": "牛啊牛啊",
          "chicken": "你干嘛，哎呦~"
     }
     if (!name) {
          return `entity.${entityId}.name`
     } else if (name == "奶糖也不是很甜" && Object.keys(entityName).some(key => key.startsWith(entityId))) {
          return name + `(§b${entityName[entityId]}§r)`
     } else if (name == 'MaxCypher') {
          return name + `(§b竟然是"天下无双"!§r)`
     } else {
          return name
     }
}

function displayEntityHealth(player, defaultHealth, health, maxHealth) {
     const entityHealth = Math.ceil(health)
     const residualBlood = entityHealth <= maxHealth * (player.getDynamicProperty('残血') * 0.01) ? `§c${entityHealth}§r` : entityHealth
     if (player.getDynamicProperty('生物生命值')) {
          if (player.getDynamicProperty('使用爱心')) {
               return `\n${(health <= 20 && defaultHealth <= 20) ? displayIconHealth(health, maxHealth, defaultHealth) : Hurt + residualBlood + '/' + maxHealth}`
          } else {
               return `\n${Hurt}${residualBlood}/${maxHealth}`
          }
     } else {
          return ''
     }
}