import { tool, toolLevel, toolName } from "./tool"
import { useSword, usePickaxe, useAxe, useShovel, useHoe, useShears } from "./blockTypeId"
/**
 * 如果你是从tool.js过来的请继续往下看，若不是请打开tool.js
 * 把你刚刚添加的新的工具按照我的写法依次写进这四个函数中就行了
 * 因为是根据工具id判断的工具类型（剑，镐子什么的）所以在自定义工具时请尽量标准命名，避免无发生识别
 * 
 */
export function needeToolType(mcid,block) {
     let tag = block?.getTags()
     if (useSword[mcid] || tag.includes('minecraft:useSword')) {
          return toolName.sword
     } else if (usePickaxe[mcid] || tag.includes('minecraft:usePickaxe')) {
          return toolName.pickaxe
     } else if (useAxe[mcid] || tag.includes('minecraft:useAxe')) {
          return toolName.axe
     } else if (useShovel[mcid] || tag.includes('minecraft:useShovel')) {
          return toolName.shovel
     } else if (useHoe[mcid] || tag.includes('minecraft:useHoe')) {
          return toolName.hoe
     } else if (useShears[mcid] || tag.includes('minecraft:useShears')) {
          return toolName.shears
     } else {
          return toolName.hand
     }
}
export function handToolType(hand) {
     let id
     let tag = hand?.getTags()
     try {
          id = hand.typeId
     } catch {
          return toolName.hand
     }
     if (id.includes("sword") || tag.includes('minecraft:is_sword')) {
          return toolName.sword
     } else if (tag.includes('minecraft:is_pickaxe')) {
          return toolName.pickaxe
     } else if (id.includes("axe")|| tag.includes('minecraft:is_axe'))  {
          return toolName.axe
     } else if (id.includes("shovel")|| tag.includes('minecraft:is_shovel')) {
          return toolName.shovel
     } else if (id.includes("hoe")|| tag.includes('minecraft:is_hoe')) {
          return toolName.hoe
     } if (id.includes("shears") || tag.includes('minecraft:is_shears')) {
          return toolName.shears
     } else {
          return toolName.hand
     }
}
export function handToolLevel(hand) {
     let tag = hand?.getTags()
     let id
     try {
          id = hand.typeId
     } catch {
          return toolLevel.hand
     }
     function includesTool(material) {
          return tool[material] && tool[material].some(item => id.includes(item));
     }
     if (includesTool("wooden") || includesTool("golden") || tag.includes('minecraft:toolLevel_1')) {
          return toolLevel.wooden
     } else if (includesTool("stone") || tag.includes('minecraft:toolLevel_2')) {
          return toolLevel.stone
     } else if (includesTool("iron") || tag.includes('minecraft:toolLevel_3')) {
          return toolLevel.iron
     } else if (includesTool("diamond") || tag.includes('minecraft:toolLevel_4')) {
          return toolLevel.diamond
     } else if (includesTool("netherite") || tag.includes('minecraft:toolLevel_5')) {
          return toolLevel.netherite
     } else if (includesTool("shears") || tag.includes('minecraft:toolLevel_1')) {
          return toolLevel.shears
     } else {
          return toolLevel.hand
     }
}
export function needeToolLevel(mcid,block)  {
     let tag = block?.getTags()
     if (useSword[mcid] || tag.includes('minecraft:toolLevel_1')) {
          return useSword[mcid]
     } else if (usePickaxe[mcid] || tag.includes('minecraft:toolLevel_2')) {
          return usePickaxe[mcid]
     } else if (useShovel[mcid] || tag.includes('minecraft:toolLevel_3')) {
          return useShovel[mcid]
     } else if (useAxe[mcid] || tag.includes('minecraft:toolLevel_4')) {
          return useAxe[mcid]
     } else if (useHoe[mcid] || tag.includes('minecraft:toolLevel_5')) {
          return useHoe[mcid]
     } if (useShears[mcid] || tag.includes('minecraft:toolLevel_1')) {
          return useShears[mcid]
     } else {
          return 0
     }
}